version: "3.3"

services:
  app:
    restart: unless-stopped
    env_file:
      - .env
    pull_policy: always
    logging:
      driver: $${DOCKER_LOG_DRIVER:-json-file}

    image: "{{ image }}"

    {# remove image and environment keys from to_yaml since they are handled separately -#}
    {% set extrakeys = container | map_value | dict2items |
          rejectattr('key', 'eq', 'environment') |
          rejectattr('key', 'eq', 'image') |
          list | items2dict
    %}
    {% if extrakeys %}
    {% filter indent(width=4, first=false) -%}
      {{ extrakeys | to_yaml }}
    {% endfilter -%}
    {% endif %}

    {#- also perform ip -> host mapping on container env #}
    environment:
      {% for name, value in container.environment.items() -%}
      {%   if value and value is ansible.utils.ip_address -%}
      {%     set svc_host = "unfurl.svc-" ~ {'to_dns_label': name} | eval -%}
      {%     set _ = hosts.update({svc_host: value}) -%}
      {%     set value = svc_host -%}
      {%   endif -%}
      {{ name }}: "{{ value if value is not none else '' }}"
      {% else -%}
      {}
      {% endfor -%}

    {%- if enable_caddy %}
    labels:
      caddy: "{{ domain }}"
      # serve static content for caddy health check
      caddy.handle: /__unfurl/proxy_health
      caddy.handle.respond: '"CADDY OK" 200'
      caddy.handle.header: 'Access-Control-Allow-Origin *'

      # route rest of traffic to upstream
      {# escape the {{s needed for caddy label -#}
      caddy.reverse_proxy: "{{ '{{ upstreams ' ~ port ~ ' }}' }}"

      # TODO find a safe way to reenable this
      # known to cause caddy to determine that there are no upstreams
      # caddy.reverse_proxy.health_uri: "$${CONTAINER_HEALTH_CHECK:-/}"
    {% endif -%}

    {%- if hosts|length > 0 %}
    # add host remapping for service ips
    extra_hosts:
      {% for host, ip in hosts.items() -%}
      - "{{ host }}:{{ ip }}"
      {% endfor -%}
    {% endif -%}

{%- if "volumes" in container %}
volumes:
  {% for v in container.volumes if v is not match(".*/.*:") -%}
    {% set src, dest = v.split(':') -%}
    {{ src }}:
  {% else -%}
    {}
  {% endfor -%}
{% endif %}

networks:
  default:
    external:
      name: "$${DOCKER_NETWORK:-web}"
